/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	getambassadoriov1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis_ambassador/getambassador.io/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeMappings implements MappingInterface
type FakeMappings struct {
	Fake *FakeGetambassadorV1
	ns   string
}

var mappingsResource = schema.GroupVersionResource{Group: "getambassador.io", Version: "v1", Resource: "mappings"}

var mappingsKind = schema.GroupVersionKind{Group: "getambassador.io", Version: "v1", Kind: "Mapping"}

// Get takes name of the mapping, and returns the corresponding mapping object, and an error if there is any.
func (c *FakeMappings) Get(name string, options v1.GetOptions) (result *getambassadoriov1.Mapping, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(mappingsResource, c.ns, name), &getambassadoriov1.Mapping{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.Mapping), err
}

// List takes label and field selectors, and returns the list of Mappings that match those selectors.
func (c *FakeMappings) List(opts v1.ListOptions) (result *getambassadoriov1.MappingList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(mappingsResource, mappingsKind, c.ns, opts), &getambassadoriov1.MappingList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &getambassadoriov1.MappingList{ListMeta: obj.(*getambassadoriov1.MappingList).ListMeta}
	for _, item := range obj.(*getambassadoriov1.MappingList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested mappings.
func (c *FakeMappings) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(mappingsResource, c.ns, opts))

}

// Create takes the representation of a mapping and creates it.  Returns the server's representation of the mapping, and an error, if there is any.
func (c *FakeMappings) Create(mapping *getambassadoriov1.Mapping) (result *getambassadoriov1.Mapping, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(mappingsResource, c.ns, mapping), &getambassadoriov1.Mapping{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.Mapping), err
}

// Update takes the representation of a mapping and updates it. Returns the server's representation of the mapping, and an error, if there is any.
func (c *FakeMappings) Update(mapping *getambassadoriov1.Mapping) (result *getambassadoriov1.Mapping, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(mappingsResource, c.ns, mapping), &getambassadoriov1.Mapping{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.Mapping), err
}

// Delete takes name of the mapping and deletes it. Returns an error if one occurs.
func (c *FakeMappings) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(mappingsResource, c.ns, name), &getambassadoriov1.Mapping{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeMappings) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(mappingsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &getambassadoriov1.MappingList{})
	return err
}

// Patch applies the patch and returns the patched mapping.
func (c *FakeMappings) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *getambassadoriov1.Mapping, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(mappingsResource, c.ns, name, pt, data, subresources...), &getambassadoriov1.Mapping{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.Mapping), err
}
